﻿using NUnit.Framework;

namespace AutoMapper.UnitTests.Bug
{
    public class SubclassMappings : AutoMapperSpecBase
    {
        public class Source
        {
            public string Name { get; set; }
        }

        public class Destination
        {
            public string Name { get; set; }
        }

        public class SubDestination : Destination
        {
            public string SubName { get; set; }
        }

        protected override void Establish_context()
        {
            AutoMapper.Mapper.CreateMap<Source, Destination>();
        }

        [Test]
        public void TestCase()
        {

            var source = new Source() { Name = "Test" };
            var destination = new Destination();

            AutoMapper.Mapper.Map<Source, Destination>(source, destination); // Works

            var subDestination = new SubDestination();

            AutoMapper.Mapper.Map<Source, Destination>(source, subDestination); // Fails
        }
    }
}